Apache NiFi REST API

REST API definition for Apache NiFi web services
More information: https://nifi.apache.org
Contact Info: dev@nifi.apache.org
Version: 2.0.0
Apache 2.0
https://www.apache.org/licenses/LICENSE-2.0.html

Access

Methods

[ Jump to Models ]

Table of Contents

Access

Authentication

Connections

Controller

ControllerServices

Counters

DataTransfer

Flow

FlowFileQueues

Funnels

InputPorts

Labels

OutputPorts

ParameterContexts

ParameterProviders

Policies

ProcessGroups

Processors

Provenance

ProvenanceEvents

RemoteProcessGroups

ReportingTasks

Resources

SiteToSite

Snippets

SystemDiagnostics

Tenants

Versions

Access

Up
post /access/token
Creates a token for accessing the REST API via username/password (createAccessToken)
The token returned is formatted as a JSON Web Token (JWT). The token is base64 encoded and comprised of three parts. The header, the body, and the signature. The expiration of the token is a contained within the body. It is stored in the browser as a cookie, but also returned inthe response body to be stored/used by third party client scripts.

Consumes

This API call consumes the following media types via the Content-Type request header:

Form parameters

username (optional)
Form Parameter
password (optional)
Form Parameter

Return type

String

Example data

Content-Type: application/json
""

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

String

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

500

Unable to create access token because an unexpected error occurred.

Up
delete /access/logout
Performs a logout for other providers that have been issued a JWT. (logOut)
Note: This endpoint is subject to change as NiFi and it's REST API evolve.

Responses

200

User was logged out successfully.

401

Authentication token provided was empty or not in the correct JWT format.

500

Client failed to log out.

Up
get /access/logout/complete
Completes the logout sequence by removing the cached Logout Request and Cookie if they existed and redirects to /nifi/login. (logOutComplete)
Note: This endpoint is subject to change as NiFi and it's REST API evolve.

Responses

200

User was logged out successfully.

401

Authentication token provided was empty or not in the correct JWT format.

500

Client failed to log out.

Authentication

Up
get /authentication/configuration
Retrieves the authentication configuration endpoint and status information (getAuthenticationConfiguration)

Return type

AuthenticationConfigurationEntity

Example data

Content-Type: application/json
{
  "authenticationConfiguration" : {
    "logoutUri" : "logoutUri",
    "loginUri" : "loginUri",
    "externalLoginRequired" : true,
    "loginSupported" : true
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

AuthenticationConfigurationEntity

Connections

Up
delete /connections/{id}
Deletes a connection (deleteConnection)

Path parameters

id (required)
Path Parameter — The connection id.

Query parameters

version (optional)
Query Parameter — The revision is used to verify the client is working with the latest version of the flow.
clientId (optional)
Query Parameter — If the client id is not specified, new one will be generated. This value (whether specified or generated) is included in the response.
disconnectedNodeAcknowledged (optional)
Query Parameter — Acknowledges that this node is disconnected to allow for mutable requests to proceed. default: false

Return type

ConnectionEntity

Example data

Content-Type: application/json
{
  "sourceId" : "sourceId",
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "destinationGroupId" : "destinationGroupId",
  "labelIndex" : 5,
  "destinationId" : "destinationId",
  "uri" : "uri",
  "bends" : [ null, null ],
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  },
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "prioritizers" : [ "prioritizers", "prioritizers" ],
    "flowFileExpiration" : "flowFileExpiration",
    "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
    "loadBalanceCompression" : "DO_NOT_COMPRESS, COMPRESS_ATTRIBUTES_ONLY, COMPRESS_ATTRIBUTES_AND_CONTENT",
    "parentGroupId" : "parentGroupId",
    "availableRelationships" : [ "availableRelationships", "availableRelationships" ],
    "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
    "loadBalanceStrategy" : "DO_NOT_LOAD_BALANCE, PARTITION_BY_ATTRIBUTE, ROUND_ROBIN, SINGLE_NODE",
    "source" : {
      "running" : true,
      "comments" : "comments",
      "versionedComponentId" : "versionedComponentId",
      "groupId" : "groupId",
      "name" : "name",
      "transmitting" : true,
      "exists" : true,
      "id" : "id",
      "type" : "PROCESSOR, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, INPUT_PORT, OUTPUT_PORT, FUNNEL"
    },
    "labelIndex" : 0,
    "bends" : [ null, null ],
    "loadBalanceStatus" : "LOAD_BALANCE_NOT_CONFIGURED, LOAD_BALANCE_INACTIVE, LOAD_BALANCE_ACTIVE",
    "backPressureObjectThreshold" : 1,
    "versionedComponentId" : "versionedComponentId",
    "getzIndex" : 6,
    "name" : "name",
    "id" : "id",
    "loadBalancePartitionAttribute" : "loadBalancePartitionAttribute"
  },
  "sourceType" : "PROCESSOR, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, INPUT_PORT, OUTPUT_PORT, FUNNEL",
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "getzIndex" : 9,
  "destinationType" : "PROCESSOR, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, INPUT_PORT, OUTPUT_PORT, FUNNEL",
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "status" : {
    "sourceId" : "sourceId",
    "groupId" : "groupId",
    "destinationName" : "destinationName",
    "name" : "name",
    "nodeSnapshots" : [ {
      "address" : "address",
      "apiPort" : 4,
      "nodeId" : "nodeId"
    }, {
      "address" : "address",
      "apiPort" : 4,
      "nodeId" : "nodeId"
    } ],
    "id" : "id",
    "sourceName" : "sourceName",
    "aggregateSnapshot" : {
      "sourceId" : "sourceId",
      "groupId" : "groupId",
      "queued" : "queued",
      "percentUseCount" : 7,
      "destinationId" : "destinationId",
      "predictions" : {
        "predictedBytesAtNextInterval" : 9,
        "predictionIntervalSeconds" : 2,
        "predictedPercentBytes" : 2,
        "predictedPercentCount" : 3,
        "predictedMillisUntilCountBackpressure" : 5,
        "predictedCountAtNextInterval" : 7,
        "predictedMillisUntilBytesBackpressure" : 5
      },
      "output" : "output",
      "input" : "input",
      "percentUseBytes" : 1,
      "flowFileAvailability" : "flowFileAvailability",
      "destinationName" : "destinationName",
      "queuedSize" : "queuedSize",
      "queuedCount" : "queuedCount",
      "name" : "name",
      "flowFilesQueued" : 1,
      "id" : "id",
      "sourceName" : "sourceName",
      "flowFilesIn" : 4,
      "flowFilesOut" : 1,
      "bytesIn" : 7,
      "bytesOut" : 1,
      "bytesQueued" : 6
    },
    "destinationId" : "destinationId",
    "statsLastRefreshed" : "statsLastRefreshed"
  },
  "sourceGroupId" : "sourceGroupId"
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ConnectionEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /connections/{id}
Gets a connection (getConnection)

Path parameters

id (required)
Path Parameter — The connection id.

Return type

ConnectionEntity

Example data

Content-Type: application/json
{
  "sourceId" : "sourceId",
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "destinationGroupId" : "destinationGroupId",
  "labelIndex" : 5,
  "destinationId" : "destinationId",
  "uri" : "uri",
  "bends" : [ null, null ],
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  },
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "prioritizers" : [ "prioritizers", "prioritizers" ],
    "flowFileExpiration" : "flowFileExpiration",
    "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
    "loadBalanceCompression" : "DO_NOT_COMPRESS, COMPRESS_ATTRIBUTES_ONLY, COMPRESS_ATTRIBUTES_AND_CONTENT",
    "parentGroupId" : "parentGroupId",
    "availableRelationships" : [ "availableRelationships", "availableRelationships" ],
    "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
    "loadBalanceStrategy" : "DO_NOT_LOAD_BALANCE, PARTITION_BY_ATTRIBUTE, ROUND_ROBIN, SINGLE_NODE",
    "source" : {
      "running" : true,
      "comments" : "comments",
      "versionedComponentId" : "versionedComponentId",
      "groupId" : "groupId",
      "name" : "name",
      "transmitting" : true,
      "exists" : true,
      "id" : "id",
      "type" : "PROCESSOR, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, INPUT_PORT, OUTPUT_PORT, FUNNEL"
    },
    "labelIndex" : 0,
    "bends" : [ null, null ],
    "loadBalanceStatus" : "LOAD_BALANCE_NOT_CONFIGURED, LOAD_BALANCE_INACTIVE, LOAD_BALANCE_ACTIVE",
    "backPressureObjectThreshold" : 1,
    "versionedComponentId" : "versionedComponentId",
    "getzIndex" : 6,
    "name" : "name",
    "id" : "id",
    "loadBalancePartitionAttribute" : "loadBalancePartitionAttribute"
  },
  "sourceType" : "PROCESSOR, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, INPUT_PORT, OUTPUT_PORT, FUNNEL",
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "getzIndex" : 9,
  "destinationType" : "PROCESSOR, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, INPUT_PORT, OUTPUT_PORT, FUNNEL",
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "status" : {
    "sourceId" : "sourceId",
    "groupId" : "groupId",
    "destinationName" : "destinationName",
    "name" : "name",
    "nodeSnapshots" : [ {
      "address" : "address",
      "apiPort" : 4,
      "nodeId" : "nodeId"
    }, {
      "address" : "address",
      "apiPort" : 4,
      "nodeId" : "nodeId"
    } ],
    "id" : "id",
    "sourceName" : "sourceName",
    "aggregateSnapshot" : {
      "sourceId" : "sourceId",
      "groupId" : "groupId",
      "queued" : "queued",
      "percentUseCount" : 7,
      "destinationId" : "destinationId",
      "predictions" : {
        "predictedBytesAtNextInterval" : 9,
        "predictionIntervalSeconds" : 2,
        "predictedPercentBytes" : 2,
        "predictedPercentCount" : 3,
        "predictedMillisUntilCountBackpressure" : 5,
        "predictedCountAtNextInterval" : 7,
        "predictedMillisUntilBytesBackpressure" : 5
      },
      "output" : "output",
      "input" : "input",
      "percentUseBytes" : 1,
      "flowFileAvailability" : "flowFileAvailability",
      "destinationName" : "destinationName",
      "queuedSize" : "queuedSize",
      "queuedCount" : "queuedCount",
      "name" : "name",
      "flowFilesQueued" : 1,
      "id" : "id",
      "sourceName" : "sourceName",
      "flowFilesIn" : 4,
      "flowFilesOut" : 1,
      "bytesIn" : 7,
      "bytesOut" : 1,
      "bytesQueued" : 6
    },
    "destinationId" : "destinationId",
    "statsLastRefreshed" : "statsLastRefreshed"
  },
  "sourceGroupId" : "sourceGroupId"
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ConnectionEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
put /connections/{id}
Updates a connection (updateConnection)

Path parameters

id (required)
Path Parameter — The connection id.

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body ConnectionEntity (required)
Body Parameter — The connection configuration details.

Return type

ConnectionEntity

Example data

Content-Type: application/json
{
  "sourceId" : "sourceId",
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "destinationGroupId" : "destinationGroupId",
  "labelIndex" : 5,
  "destinationId" : "destinationId",
  "uri" : "uri",
  "bends" : [ null, null ],
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  },
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "prioritizers" : [ "prioritizers", "prioritizers" ],
    "flowFileExpiration" : "flowFileExpiration",
    "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
    "loadBalanceCompression" : "DO_NOT_COMPRESS, COMPRESS_ATTRIBUTES_ONLY, COMPRESS_ATTRIBUTES_AND_CONTENT",
    "parentGroupId" : "parentGroupId",
    "availableRelationships" : [ "availableRelationships", "availableRelationships" ],
    "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
    "loadBalanceStrategy" : "DO_NOT_LOAD_BALANCE, PARTITION_BY_ATTRIBUTE, ROUND_ROBIN, SINGLE_NODE",
    "source" : {
      "running" : true,
      "comments" : "comments",
      "versionedComponentId" : "versionedComponentId",
      "groupId" : "groupId",
      "name" : "name",
      "transmitting" : true,
      "exists" : true,
      "id" : "id",
      "type" : "PROCESSOR, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, INPUT_PORT, OUTPUT_PORT, FUNNEL"
    },
    "labelIndex" : 0,
    "bends" : [ null, null ],
    "loadBalanceStatus" : "LOAD_BALANCE_NOT_CONFIGURED, LOAD_BALANCE_INACTIVE, LOAD_BALANCE_ACTIVE",
    "backPressureObjectThreshold" : 1,
    "versionedComponentId" : "versionedComponentId",
    "getzIndex" : 6,
    "name" : "name",
    "id" : "id",
    "loadBalancePartitionAttribute" : "loadBalancePartitionAttribute"
  },
  "sourceType" : "PROCESSOR, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, INPUT_PORT, OUTPUT_PORT, FUNNEL",
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "getzIndex" : 9,
  "destinationType" : "PROCESSOR, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, INPUT_PORT, OUTPUT_PORT, FUNNEL",
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "status" : {
    "sourceId" : "sourceId",
    "groupId" : "groupId",
    "destinationName" : "destinationName",
    "name" : "name",
    "nodeSnapshots" : [ {
      "address" : "address",
      "apiPort" : 4,
      "nodeId" : "nodeId"
    }, {
      "address" : "address",
      "apiPort" : 4,
      "nodeId" : "nodeId"
    } ],
    "id" : "id",
    "sourceName" : "sourceName",
    "aggregateSnapshot" : {
      "sourceId" : "sourceId",
      "groupId" : "groupId",
      "queued" : "queued",
      "percentUseCount" : 7,
      "destinationId" : "destinationId",
      "predictions" : {
        "predictedBytesAtNextInterval" : 9,
        "predictionIntervalSeconds" : 2,
        "predictedPercentBytes" : 2,
        "predictedPercentCount" : 3,
        "predictedMillisUntilCountBackpressure" : 5,
        "predictedCountAtNextInterval" : 7,
        "predictedMillisUntilBytesBackpressure" : 5
      },
      "output" : "output",
      "input" : "input",
      "percentUseBytes" : 1,
      "flowFileAvailability" : "flowFileAvailability",
      "destinationName" : "destinationName",
      "queuedSize" : "queuedSize",
      "queuedCount" : "queuedCount",
      "name" : "name",
      "flowFilesQueued" : 1,
      "id" : "id",
      "sourceName" : "sourceName",
      "flowFilesIn" : 4,
      "flowFilesOut" : 1,
      "bytesIn" : 7,
      "bytesOut" : 1,
      "bytesQueued" : 6
    },
    "destinationId" : "destinationId",
    "statsLastRefreshed" : "statsLastRefreshed"
  },
  "sourceGroupId" : "sourceGroupId"
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ConnectionEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Controller

Up
post /controller/flow-analysis-rules/{id}/config/analysis
Performs analysis of the component's configuration, providing information about which attributes are referenced. (analyzeFlowAnalysisRuleConfiguration)

Path parameters

id (required)
Path Parameter — The flow analysis rules id.

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

Body Parameter — The configuration analysis request.

Return type

ConfigurationAnalysisEntity

Example data

Content-Type: application/json
{
  "configurationAnalysis" : {
    "componentId" : "componentId",
    "referencedAttributes" : {
      "key" : "referencedAttributes"
    },
    "supportsVerification" : true,
    "properties" : {
      "key" : "properties"
    }
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ConfigurationAnalysisEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /controller/flow-analysis-rules/{id}/state/clear-requests
Clears the state for a flow analysis rule (clearState)

Path parameters

id (required)
Path Parameter — The flow analysis rule id.

Return type

ComponentStateEntity

Example data

Content-Type: application/json
{
  "componentState" : {
    "componentId" : "componentId",
    "stateDescription" : "stateDescription",
    "clusterState" : {
      "totalEntryCount" : 0,
      "scope" : "scope",
      "state" : [ {
        "clusterNodeId" : "clusterNodeId",
        "clusterNodeAddress" : "clusterNodeAddress",
        "value" : "value",
        "key" : "key"
      }, {
        "clusterNodeId" : "clusterNodeId",
        "clusterNodeAddress" : "clusterNodeAddress",
        "value" : "value",
        "key" : "key"
      } ]
    }
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ComponentStateEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /controller/bulletin
Creates a new bulletin (createBulletin)

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body BulletinEntity (required)
Body Parameter — The reporting task configuration details.

Return type

BulletinEntity

Example data

Content-Type: application/json
{
  "sourceId" : "sourceId",
  "canRead" : true,
  "groupId" : "groupId",
  "id" : 5,
  "nodeAddress" : "nodeAddress",
  "bulletin" : {
    "sourceId" : "sourceId",
    "level" : "level",
    "sourceType" : "sourceType",
    "groupId" : "groupId",
    "id" : 5,
    "sourceName" : "sourceName",
    "category" : "category",
    "message" : "message",
    "nodeAddress" : "nodeAddress",
    "timestamp" : "timestamp"
  },
  "timestamp" : "timestamp"
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

BulletinEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /controller/controller-services
Creates a new controller service (createControllerService)

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body ControllerServiceEntity (required)
Body Parameter — The controller service configuration details.

Return type

ControllerServiceEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "deprecated" : true,
    "bulletinLevel" : "bulletinLevel",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "type" : "type",
    "descriptors" : {
      "key" : {
        "supportsEl" : true,
        "displayName" : "displayName",
        "defaultValue" : "defaultValue",
        "expressionLanguageScope" : "expressionLanguageScope",
        "description" : "description",
        "sensitive" : true,
        "required" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        } ],
        "allowableValues" : [ {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        }, {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        } ],
        "identifiesControllerService" : "identifiesControllerService",
        "name" : "name",
        "dynamic" : true
      }
    },
    "controllerServiceApis" : [ {
      "type" : "type"
    }, {
      "type" : "type"
    } ],
    "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
    "versionedComponentId" : "versionedComponentId",
    "supportsSensitiveDynamicProperties" : true,
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "state" : "ENABLED, ENABLING, DISABLED, DISABLING",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "referencingComponents" : [ {
      "bulletins" : [ null, null ],
      "disconnectedNodeAcknowledged" : true,
      "component" : {
        "descriptors" : { },
        "referenceCycle" : true,
        "activeThreadCount" : 0,
        "groupId" : "groupId",
        "name" : "name",
        "validationErrors" : [ "validationErrors", "validationErrors" ],
        "referenceType" : "Processor, ControllerService, ReportingTask, FlowRegistryClient",
        "id" : "id",
        "state" : "state",
        "type" : "type",
        "referencingComponents" : [ null, null ],
        "properties" : {
          "key" : "properties"
        }
      },
      "id" : "id",
      "uri" : "uri"
    }, {
      "bulletins" : [ null, null ],
      "disconnectedNodeAcknowledged" : true,
      "component" : {
        "descriptors" : { },
        "referenceCycle" : true,
        "activeThreadCount" : 0,
        "groupId" : "groupId",
        "name" : "name",
        "validationErrors" : [ "validationErrors", "validationErrors" ],
        "referenceType" : "Processor, ControllerService, ReportingTask, FlowRegistryClient",
        "id" : "id",
        "state" : "state",
        "type" : "type",
        "referencingComponents" : [ null, null ],
        "properties" : {
          "key" : "properties"
        }
      },
      "id" : "id",
      "uri" : "uri"
    } ],
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "annotationData" : "annotationData",
    "comments" : "comments",
    "parentGroupId" : "parentGroupId",
    "customUiUrl" : "customUiUrl",
    "restricted" : true,
    "name" : "name",
    "persistsState" : true,
    "properties" : {
      "key" : "properties"
    }
  },
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "parentGroupId" : "parentGroupId",
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "uri" : "uri",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  },
  "status" : {
    "activeThreadCount" : 6,
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "runStatus" : "ENABLED, ENABLING, DISABLED, DISABLING"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ControllerServiceEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /controller/flow-analysis-rules
Creates a new flow analysis rule (createFlowAnalysisRule)

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body FlowAnalysisRuleEntity (required)
Body Parameter — The flow analysis rule configuration details.

Return type

FlowAnalysisRuleEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "comments" : "comments",
    "deprecated" : true,
    "enforcementPolicy" : "enforcementPolicy",
    "parentGroupId" : "parentGroupId",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "type" : "type",
    "descriptors" : {
      "key" : {
        "supportsEl" : true,
        "displayName" : "displayName",
        "defaultValue" : "defaultValue",
        "expressionLanguageScope" : "expressionLanguageScope",
        "description" : "description",
        "sensitive" : true,
        "required" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        } ],
        "allowableValues" : [ {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        }, {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        } ],
        "identifiesControllerService" : "identifiesControllerService",
        "name" : "name",
        "dynamic" : true
      }
    },
    "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
    "restricted" : true,
    "versionedComponentId" : "versionedComponentId",
    "supportsSensitiveDynamicProperties" : true,
    "name" : "name",
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "state" : "ENABLED, DISABLED",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "persistsState" : true,
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "properties" : {
      "key" : "properties"
    }
  },
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "uri" : "uri",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  },
  "status" : {
    "activeThreadCount" : 0,
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "runStatus" : "ENABLED, DISABLED"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

FlowAnalysisRuleEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /controller/registry-clients
Creates a new flow registry client (createFlowRegistryClient)

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body FlowRegistryClientEntity (required)
Body Parameter — The flow registry client configuration details.

Return type

FlowRegistryClientEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "annotationData" : "annotationData",
    "deprecated" : true,
    "description" : "description",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "type" : "type",
    "descriptors" : {
      "key" : {
        "supportsEl" : true,
        "displayName" : "displayName",
        "defaultValue" : "defaultValue",
        "expressionLanguageScope" : "expressionLanguageScope",
        "description" : "description",
        "sensitive" : true,
        "required" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        } ],
        "allowableValues" : [ {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        }, {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        } ],
        "identifiesControllerService" : "identifiesControllerService",
        "name" : "name",
        "dynamic" : true
      }
    },
    "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
    "supportsBranching" : true,
    "restricted" : true,
    "supportsSensitiveDynamicProperties" : true,
    "name" : "name",
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "properties" : {
      "key" : "properties"
    }
  },
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "uri" : "uri",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

FlowRegistryClientEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /controller/parameter-providers
Creates a new parameter provider (createParameterProvider)

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body ParameterProviderEntity (required)
Body Parameter — The parameter provider configuration details.

Return type

ParameterProviderEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "annotationData" : "annotationData",
    "comments" : "comments",
    "deprecated" : true,
    "parameterStatus" : [ {
      "parameter" : {
        "parameter" : {
          "valueRemoved" : true,
          "referencedAssets" : [ {
            "name" : "name",
            "id" : "id"
          }, {
            "name" : "name",
            "id" : "id"
          } ],
          "inherited" : true,
          "provided" : true,
          "name" : "name",
          "description" : "description",
          "sensitive" : true,
          "value" : "value",
          "referencingComponents" : [ null, null ],
          "parameterContext" : {
            "component" : {
              "name" : "name",
              "id" : "id"
            },
            "id" : "id"
          }
        },
        "canWrite" : true
      },
      "status" : "NEW"
    }, {
      "parameter" : {
        "parameter" : {
          "valueRemoved" : true,
          "referencedAssets" : [ {
            "name" : "name",
            "id" : "id"
          }, {
            "name" : "name",
            "id" : "id"
          } ],
          "inherited" : true,
          "provided" : true,
          "name" : "name",
          "description" : "description",
          "sensitive" : true,
          "value" : "value",
          "referencingComponents" : [ null, null ],
          "parameterContext" : {
            "component" : {
              "name" : "name",
              "id" : "id"
            },
            "id" : "id"
          }
        },
        "canWrite" : true
      },
      "status" : "NEW"
    } ],
    "parentGroupId" : "parentGroupId",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "type" : "type",
    "affectedComponents" : [ {
      "bulletins" : [ null, null ],
      "disconnectedNodeAcknowledged" : true,
      "component" : {
        "activeThreadCount" : 0,
        "processGroupId" : "processGroupId",
        "name" : "name",
        "referenceType" : "PROCESSOR,CONTROLLER_SERVICE, INPUT_PORT, OUTPUT_PORT, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, STATELESS_GROUP",
        "validationErrors" : [ "validationErrors", "validationErrors" ],
        "id" : "id",
        "state" : "state"
      },
      "referenceType" : "PROCESSOR,CONTROLLER_SERVICE, INPUT_PORT, OUTPUT_PORT, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT",
      "id" : "id",
      "uri" : "uri",
      "processGroup" : {
        "name" : "name",
        "id" : "id"
      }
    }, {
      "bulletins" : [ null, null ],
      "disconnectedNodeAcknowledged" : true,
      "component" : {
        "activeThreadCount" : 0,
        "processGroupId" : "processGroupId",
        "name" : "name",
        "referenceType" : "PROCESSOR,CONTROLLER_SERVICE, INPUT_PORT, OUTPUT_PORT, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT, STATELESS_GROUP",
        "validationErrors" : [ "validationErrors", "validationErrors" ],
        "id" : "id",
        "state" : "state"
      },
      "referenceType" : "PROCESSOR,CONTROLLER_SERVICE, INPUT_PORT, OUTPUT_PORT, REMOTE_INPUT_PORT, REMOTE_OUTPUT_PORT",
      "id" : "id",
      "uri" : "uri",
      "processGroup" : {
        "name" : "name",
        "id" : "id"
      }
    } ],
    "customUiUrl" : "customUiUrl",
    "descriptors" : {
      "key" : {
        "supportsEl" : true,
        "displayName" : "displayName",
        "defaultValue" : "defaultValue",
        "expressionLanguageScope" : "expressionLanguageScope",
        "description" : "description",
        "sensitive" : true,
        "required" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        } ],
        "allowableValues" : [ {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        }, {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        } ],
        "identifiesControllerService" : "identifiesControllerService",
        "name" : "name",
        "dynamic" : true
      }
    },
    "referencingParameterContexts" : [ {
      "bulletins" : [ null, null ],
      "disconnectedNodeAcknowledged" : true,
      "component" : {
        "name" : "name",
        "id" : "id"
      },
      "id" : "id",
      "uri" : "uri"
    }, {
      "bulletins" : [ null, null ],
      "disconnectedNodeAcknowledged" : true,
      "component" : {
        "name" : "name",
        "id" : "id"
      },
      "id" : "id",
      "uri" : "uri"
    } ],
    "parameterGroupConfigurations" : [ {
      "synchronized" : true,
      "groupName" : "groupName",
      "parameterSensitivities" : {
        "key" : "SENSITIVE"
      },
      "parameterContextName" : "parameterContextName"
    }, {
      "synchronized" : true,
      "groupName" : "groupName",
      "parameterSensitivities" : {
        "key" : "SENSITIVE"
      },
      "parameterContextName" : "parameterContextName"
    } ],
    "restricted" : true,
    "versionedComponentId" : "versionedComponentId",
    "name" : "name",
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "persistsState" : true,
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "properties" : {
      "key" : "properties"
    }
  },
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "uri" : "uri",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ParameterProviderEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /controller/reporting-tasks
Creates a new reporting task (createReportingTask)

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body ReportingTaskEntity (required)
Body Parameter — The reporting task configuration details.

Return type

ReportingTaskEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "deprecated" : true,
    "multipleVersionsAvailable" : true,
    "defaultSchedulingPeriod" : {
      "key" : "defaultSchedulingPeriod"
    },
    "extensionMissing" : true,
    "type" : "type",
    "descriptors" : {
      "key" : {
        "supportsEl" : true,
        "displayName" : "displayName",
        "defaultValue" : "defaultValue",
        "expressionLanguageScope" : "expressionLanguageScope",
        "description" : "description",
        "sensitive" : true,
        "required" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        } ],
        "allowableValues" : [ {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        }, {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        } ],
        "identifiesControllerService" : "identifiesControllerService",
        "name" : "name",
        "dynamic" : true
      }
    },
    "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
    "versionedComponentId" : "versionedComponentId",
    "supportsSensitiveDynamicProperties" : true,
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "state" : "RUNNING, STOPPED, DISABLED",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "annotationData" : "annotationData",
    "comments" : "comments",
    "activeThreadCount" : 0,
    "parentGroupId" : "parentGroupId",
    "customUiUrl" : "customUiUrl",
    "restricted" : true,
    "schedulingStrategy" : "schedulingStrategy",
    "name" : "name",
    "schedulingPeriod" : "schedulingPeriod",
    "persistsState" : true,
    "properties" : {
      "key" : "properties"
    }
  },
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "uri" : "uri",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  },
  "status" : {
    "activeThreadCount" : 6,
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "runStatus" : "RUNNING, STOPPED, DISABLED"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ReportingTaskEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
delete /controller/flow-analysis-rules/{id}/config/verification-requests/{requestId}
Deletes the Verification Request with the given ID (deleteFlowAnalysisRuleVerificationRequest)
Deletes the Verification Request with the given ID. After a request is created, it is expected that the client will properly clean up the request by DELETE'ing it, once the Verification process has completed. If the request is deleted before the request completes, then the Verification request will finish the step that it is currently performing and then will cancel any subsequent steps.

Path parameters

id (required)
Path Parameter — The ID of the Flow Analysis Rule
requestId (required)
Path Parameter — The ID of the Verification Request

Return type

VerifyConfigRequestEntity

Example data

Content-Type: application/json
{
  "request" : {
    "percentCompleted" : 0,
    "componentId" : "componentId",
    "uri" : "uri",
    "submissionTime" : "2000-01-23T04:56:07.000+00:00",
    "lastUpdated" : "2000-01-23T04:56:07.000+00:00",
    "requestId" : "requestId",
    "updateSteps" : [ {
      "failureReason" : "failureReason",
      "description" : "description",
      "complete" : true
    }, {
      "failureReason" : "failureReason",
      "description" : "description",
      "complete" : true
    } ],
    "failureReason" : "failureReason",
    "attributes" : {
      "key" : "attributes"
    },
    "state" : "state",
    "complete" : true,
    "results" : [ {
      "verificationStepName" : "verificationStepName",
      "explanation" : "explanation",
      "outcome" : "SUCCESSFUL, FAILED, SKIPPED"
    }, {
      "verificationStepName" : "verificationStepName",
      "explanation" : "explanation",
      "outcome" : "SUCCESSFUL, FAILED, SKIPPED"
    } ],
    "properties" : {
      "key" : "properties"
    }
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

VerifyConfigRequestEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
delete /controller/registry-clients/{id}
Deletes a flow registry client (deleteFlowRegistryClient)

Path parameters

id (required)
Path Parameter — The flow registry client id.

Query parameters

version (optional)
Query Parameter — The revision is used to verify the client is working with the latest version of the flow.
clientId (optional)
Query Parameter — If the client id is not specified, new one will be generated. This value (whether specified or generated) is included in the response.
disconnectedNodeAcknowledged (optional)
Query Parameter — Acknowledges that this node is disconnected to allow for mutable requests to proceed. default: false

Return type

FlowRegistryClientEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "annotationData" : "annotationData",
    "deprecated" : true,
    "description" : "description",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "type" : "type",
    "descriptors" : {
      "key" : {
        "supportsEl" : true,
        "displayName" : "displayName",
        "defaultValue" : "defaultValue",
        "expressionLanguageScope" : "expressionLanguageScope",
        "description" : "description",
        "sensitive" : true,
        "required" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        } ],
        "allowableValues" : [ {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        }, {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        } ],
        "identifiesControllerService" : "identifiesControllerService",
        "name" : "name",
        "dynamic" : true
      }
    },
    "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
    "supportsBranching" : true,
    "restricted" : true,
    "supportsSensitiveDynamicProperties" : true,
    "name" : "name",
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "properties" : {
      "key" : "properties"
    }
  },
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "uri" : "uri",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

FlowRegistryClientEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
delete /controller/history
Purges history (deleteHistory)

Query parameters

endDate (required)
Query Parameter — Purge actions before this date/time.

Return type

HistoryEntity

Example data

Content-Type: application/json
{
  "history" : {
    "lastRefreshed" : "lastRefreshed",
    "total" : 0,
    "actions" : [ {
      "sourceId" : "sourceId",
      "canRead" : true,
      "action" : {
        "sourceId" : "sourceId",
        "componentDetails" : { },
        "sourceType" : "sourceType",
        "id" : 1,
        "userIdentity" : "userIdentity",
        "sourceName" : "sourceName",
        "actionDetails" : { },
        "operation" : "operation",
        "timestamp" : "timestamp"
      },
      "id" : 6,
      "timestamp" : "timestamp"
    }, {
      "sourceId" : "sourceId",
      "canRead" : true,
      "action" : {
        "sourceId" : "sourceId",
        "componentDetails" : { },
        "sourceType" : "sourceType",
        "id" : 1,
        "userIdentity" : "userIdentity",
        "sourceName" : "sourceName",
        "actionDetails" : { },
        "operation" : "operation",
        "timestamp" : "timestamp"
      },
      "id" : 6,
      "timestamp" : "timestamp"
    } ]
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

HistoryEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
delete /controller/nar-manager/nars/{id}
Deletes an installed NAR (deleteNar)

Path parameters

id (required)
Path Parameter — The id of the NAR.

Query parameters

disconnectedNodeAcknowledged (optional)
Query Parameter — default: false
force (optional)
Query Parameter — default: false

Return type

NarSummaryEntity

Example data

Content-Type: application/json
{
  "narSummary" : {
    "identifier" : "identifier",
    "coordinate" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "sourceIdentifier" : "sourceIdentifier",
    "installComplete" : true,
    "buildTime" : "buildTime",
    "createdBy" : "createdBy",
    "sourceType" : "sourceType",
    "digest" : "digest",
    "extensionCount" : 0,
    "state" : "state",
    "failureMessage" : "failureMessage"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

NarSummaryEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
delete /controller/cluster/nodes/{id}
Removes a node from the cluster (deleteNode)

Path parameters

id (required)
Path Parameter — The node id.

Return type

NodeEntity

Example data

Content-Type: application/json
{
  "node" : {
    "address" : "address",
    "activeThreadCount" : 6,
    "heartbeat" : "heartbeat",
    "roles" : [ "roles", "roles" ],
    "queued" : "queued",
    "nodeStartTime" : "nodeStartTime",
    "apiPort" : 0,
    "connectionRequested" : "connectionRequested",
    "flowFilesQueued" : 1,
    "flowFileBytes" : 5,
    "nodeId" : "nodeId",
    "events" : [ {
      "category" : "category",
      "message" : "message",
      "timestamp" : "timestamp"
    }, {
      "category" : "category",
      "message" : "message",
      "timestamp" : "timestamp"
    } ],
    "status" : "status",
    "bytesQueued" : 5
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

NodeEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/nar-manager/nars/{id}/content
Retrieves the content of the NAR with the given id (downloadNar)

Path parameters

id (required)
Path Parameter — The id of the NAR.

Return type

byte[]

Example data

Content-Type: application/json
""

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

byte[]

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/cluster
Gets the contents of the cluster (getCluster)
Returns the contents of the cluster including all nodes and their status.

Return type

ClusterEntity

Example data

Content-Type: application/json
{
  "cluster" : {
    "nodes" : [ {
      "address" : "address",
      "activeThreadCount" : 6,
      "heartbeat" : "heartbeat",
      "roles" : [ "roles", "roles" ],
      "queued" : "queued",
      "nodeStartTime" : "nodeStartTime",
      "apiPort" : 0,
      "connectionRequested" : "connectionRequested",
      "flowFilesQueued" : 1,
      "flowFileBytes" : 5,
      "nodeId" : "nodeId",
      "events" : [ {
        "category" : "category",
        "message" : "message",
        "timestamp" : "timestamp"
      }, {
        "category" : "category",
        "message" : "message",
        "timestamp" : "timestamp"
      } ],
      "status" : "status",
      "bytesQueued" : 5
    }, {
      "address" : "address",
      "activeThreadCount" : 6,
      "heartbeat" : "heartbeat",
      "roles" : [ "roles", "roles" ],
      "queued" : "queued",
      "nodeStartTime" : "nodeStartTime",
      "apiPort" : 0,
      "connectionRequested" : "connectionRequested",
      "flowFilesQueued" : 1,
      "flowFileBytes" : 5,
      "nodeId" : "nodeId",
      "events" : [ {
        "category" : "category",
        "message" : "message",
        "timestamp" : "timestamp"
      }, {
        "category" : "category",
        "message" : "message",
        "timestamp" : "timestamp"
      } ],
      "status" : "status",
      "bytesQueued" : 5
    } ],
    "generated" : "generated"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ClusterEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/config
Retrieves the configuration for this NiFi Controller (getControllerConfig)

Return type

ControllerConfigurationEntity

Example data

Content-Type: application/json
{
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "maxTimerDrivenThreadCount" : 0
  },
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ControllerConfigurationEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/flow-analysis-rules/{id}
Gets a flow analysis rule (getFlowAnalysisRule)

Path parameters

id (required)
Path Parameter — The flow analysis rule id.

Return type

FlowAnalysisRuleEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "comments" : "comments",
    "deprecated" : true,
    "enforcementPolicy" : "enforcementPolicy",
    "parentGroupId" : "parentGroupId",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "type" : "type",
    "descriptors" : {
      "key" : {
        "supportsEl" : true,
        "displayName" : "displayName",
        "defaultValue" : "defaultValue",
        "expressionLanguageScope" : "expressionLanguageScope",
        "description" : "description",
        "sensitive" : true,
        "required" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        } ],
        "allowableValues" : [ {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        }, {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        } ],
        "identifiesControllerService" : "identifiesControllerService",
        "name" : "name",
        "dynamic" : true
      }
    },
    "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
    "restricted" : true,
    "versionedComponentId" : "versionedComponentId",
    "supportsSensitiveDynamicProperties" : true,
    "name" : "name",
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "state" : "ENABLED, DISABLED",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "persistsState" : true,
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "properties" : {
      "key" : "properties"
    }
  },
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "uri" : "uri",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  },
  "status" : {
    "activeThreadCount" : 0,
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "runStatus" : "ENABLED, DISABLED"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

FlowAnalysisRuleEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/flow-analysis-rules/{id}/descriptors
Gets a flow analysis rule property descriptor (getFlowAnalysisRulePropertyDescriptor)

Path parameters

id (required)
Path Parameter — The flow analysis rule id.

Query parameters

propertyName (required)
Query Parameter — The property name.
sensitive (optional)
Query Parameter — Property Descriptor requested sensitive status

Return type

PropertyDescriptorEntity

Example data

Content-Type: application/json
{
  "propertyDescriptor" : {
    "supportsEl" : true,
    "displayName" : "displayName",
    "defaultValue" : "defaultValue",
    "expressionLanguageScope" : "expressionLanguageScope",
    "description" : "description",
    "sensitive" : true,
    "required" : true,
    "dependencies" : [ {
      "dependentValues" : [ "dependentValues", "dependentValues" ],
      "propertyName" : "propertyName"
    }, {
      "dependentValues" : [ "dependentValues", "dependentValues" ],
      "propertyName" : "propertyName"
    } ],
    "allowableValues" : [ {
      "canRead" : true,
      "allowableValue" : {
        "displayName" : "displayName",
        "description" : "description",
        "value" : "value"
      }
    }, {
      "canRead" : true,
      "allowableValue" : {
        "displayName" : "displayName",
        "description" : "description",
        "value" : "value"
      }
    } ],
    "identifiesControllerService" : "identifiesControllerService",
    "name" : "name",
    "dynamic" : true
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

PropertyDescriptorEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/flow-analysis-rules/{id}/state
Gets the state for a flow analysis rule (getFlowAnalysisRuleState)

Path parameters

id (required)
Path Parameter — The flow analysis rule id.

Return type

ComponentStateEntity

Example data

Content-Type: application/json
{
  "componentState" : {
    "componentId" : "componentId",
    "stateDescription" : "stateDescription",
    "clusterState" : {
      "totalEntryCount" : 0,
      "scope" : "scope",
      "state" : [ {
        "clusterNodeId" : "clusterNodeId",
        "clusterNodeAddress" : "clusterNodeAddress",
        "value" : "value",
        "key" : "key"
      }, {
        "clusterNodeId" : "clusterNodeId",
        "clusterNodeAddress" : "clusterNodeAddress",
        "value" : "value",
        "key" : "key"
      } ]
    }
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

ComponentStateEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/flow-analysis-rules/{id}/config/verification-requests/{requestId}
Returns the Verification Request with the given ID (getFlowAnalysisRuleVerificationRequest)
Returns the Verification Request with the given ID. Once an Verification Request has been created, that request can subsequently be retrieved via this endpoint, and the request that is fetched will contain the updated state, such as percent complete, the current state of the request, and any failures.

Path parameters

id (required)
Path Parameter — The ID of the Flow Analysis Rule
requestId (required)
Path Parameter — The ID of the Verification Request

Return type

VerifyConfigRequestEntity

Example data

Content-Type: application/json
{
  "request" : {
    "percentCompleted" : 0,
    "componentId" : "componentId",
    "uri" : "uri",
    "submissionTime" : "2000-01-23T04:56:07.000+00:00",
    "lastUpdated" : "2000-01-23T04:56:07.000+00:00",
    "requestId" : "requestId",
    "updateSteps" : [ {
      "failureReason" : "failureReason",
      "description" : "description",
      "complete" : true
    }, {
      "failureReason" : "failureReason",
      "description" : "description",
      "complete" : true
    } ],
    "failureReason" : "failureReason",
    "attributes" : {
      "key" : "attributes"
    },
    "state" : "state",
    "complete" : true,
    "results" : [ {
      "verificationStepName" : "verificationStepName",
      "explanation" : "explanation",
      "outcome" : "SUCCESSFUL, FAILED, SKIPPED"
    }, {
      "verificationStepName" : "verificationStepName",
      "explanation" : "explanation",
      "outcome" : "SUCCESSFUL, FAILED, SKIPPED"
    } ],
    "properties" : {
      "key" : "properties"
    }
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

VerifyConfigRequestEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/flow-analysis-rules
Gets all flow analysis rules (getFlowAnalysisRules)

Return type

FlowAnalysisRulesEntity

Example data

Content-Type: application/json
{
  "currentTime" : "currentTime",
  "flowAnalysisRules" : [ {
    "bulletins" : [ {
      "sourceId" : "sourceId",
      "canRead" : true,
      "groupId" : "groupId",
      "id" : 5,
      "nodeAddress" : "nodeAddress",
      "bulletin" : {
        "sourceId" : "sourceId",
        "level" : "level",
        "sourceType" : "sourceType",
        "groupId" : "groupId",
        "id" : 5,
        "sourceName" : "sourceName",
        "category" : "category",
        "message" : "message",
        "nodeAddress" : "nodeAddress",
        "timestamp" : "timestamp"
      },
      "timestamp" : "timestamp"
    }, {
      "sourceId" : "sourceId",
      "canRead" : true,
      "groupId" : "groupId",
      "id" : 5,
      "nodeAddress" : "nodeAddress",
      "bulletin" : {
        "sourceId" : "sourceId",
        "level" : "level",
        "sourceType" : "sourceType",
        "groupId" : "groupId",
        "id" : 5,
        "sourceName" : "sourceName",
        "category" : "category",
        "message" : "message",
        "nodeAddress" : "nodeAddress",
        "timestamp" : "timestamp"
      },
      "timestamp" : "timestamp"
    } ],
    "disconnectedNodeAcknowledged" : true,
    "component" : {
      "comments" : "comments",
      "deprecated" : true,
      "enforcementPolicy" : "enforcementPolicy",
      "parentGroupId" : "parentGroupId",
      "multipleVersionsAvailable" : true,
      "extensionMissing" : true,
      "type" : "type",
      "descriptors" : {
        "key" : {
          "supportsEl" : true,
          "displayName" : "displayName",
          "defaultValue" : "defaultValue",
          "expressionLanguageScope" : "expressionLanguageScope",
          "description" : "description",
          "sensitive" : true,
          "required" : true,
          "dependencies" : [ {
            "dependentValues" : [ "dependentValues", "dependentValues" ],
            "propertyName" : "propertyName"
          }, {
            "dependentValues" : [ "dependentValues", "dependentValues" ],
            "propertyName" : "propertyName"
          } ],
          "allowableValues" : [ {
            "canRead" : true,
            "allowableValue" : {
              "displayName" : "displayName",
              "description" : "description",
              "value" : "value"
            }
          }, {
            "canRead" : true,
            "allowableValue" : {
              "displayName" : "displayName",
              "description" : "description",
              "value" : "value"
            }
          } ],
          "identifiesControllerService" : "identifiesControllerService",
          "name" : "name",
          "dynamic" : true
        }
      },
      "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
      "restricted" : true,
      "versionedComponentId" : "versionedComponentId",
      "supportsSensitiveDynamicProperties" : true,
      "name" : "name",
      "validationErrors" : [ "validationErrors", "validationErrors" ],
      "id" : "id",
      "state" : "ENABLED, DISABLED",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "persistsState" : true,
      "validationStatus" : "VALID, INVALID, VALIDATING",
      "properties" : {
        "key" : "properties"
      }
    },
    "permissions" : {
      "canRead" : true,
      "canWrite" : true
    },
    "id" : "id",
    "position" : {
      "x" : 6.027456183070403,
      "y" : 1.4658129805029452
    },
    "uri" : "uri",
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 0
    },
    "status" : {
      "activeThreadCount" : 0,
      "validationStatus" : "VALID, INVALID, VALIDATING",
      "runStatus" : "ENABLED, DISABLED"
    }
  }, {
    "bulletins" : [ {
      "sourceId" : "sourceId",
      "canRead" : true,
      "groupId" : "groupId",
      "id" : 5,
      "nodeAddress" : "nodeAddress",
      "bulletin" : {
        "sourceId" : "sourceId",
        "level" : "level",
        "sourceType" : "sourceType",
        "groupId" : "groupId",
        "id" : 5,
        "sourceName" : "sourceName",
        "category" : "category",
        "message" : "message",
        "nodeAddress" : "nodeAddress",
        "timestamp" : "timestamp"
      },
      "timestamp" : "timestamp"
    }, {
      "sourceId" : "sourceId",
      "canRead" : true,
      "groupId" : "groupId",
      "id" : 5,
      "nodeAddress" : "nodeAddress",
      "bulletin" : {
        "sourceId" : "sourceId",
        "level" : "level",
        "sourceType" : "sourceType",
        "groupId" : "groupId",
        "id" : 5,
        "sourceName" : "sourceName",
        "category" : "category",
        "message" : "message",
        "nodeAddress" : "nodeAddress",
        "timestamp" : "timestamp"
      },
      "timestamp" : "timestamp"
    } ],
    "disconnectedNodeAcknowledged" : true,
    "component" : {
      "comments" : "comments",
      "deprecated" : true,
      "enforcementPolicy" : "enforcementPolicy",
      "parentGroupId" : "parentGroupId",
      "multipleVersionsAvailable" : true,
      "extensionMissing" : true,
      "type" : "type",
      "descriptors" : {
        "key" : {
          "supportsEl" : true,
          "displayName" : "displayName",
          "defaultValue" : "defaultValue",
          "expressionLanguageScope" : "expressionLanguageScope",
          "description" : "description",
          "sensitive" : true,
          "required" : true,
          "dependencies" : [ {
            "dependentValues" : [ "dependentValues", "dependentValues" ],
            "propertyName" : "propertyName"
          }, {
            "dependentValues" : [ "dependentValues", "dependentValues" ],
            "propertyName" : "propertyName"
          } ],
          "allowableValues" : [ {
            "canRead" : true,
            "allowableValue" : {
              "displayName" : "displayName",
              "description" : "description",
              "value" : "value"
            }
          }, {
            "canRead" : true,
            "allowableValue" : {
              "displayName" : "displayName",
              "description" : "description",
              "value" : "value"
            }
          } ],
          "identifiesControllerService" : "identifiesControllerService",
          "name" : "name",
          "dynamic" : true
        }
      },
      "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
      "restricted" : true,
      "versionedComponentId" : "versionedComponentId",
      "supportsSensitiveDynamicProperties" : true,
      "name" : "name",
      "validationErrors" : [ "validationErrors", "validationErrors" ],
      "id" : "id",
      "state" : "ENABLED, DISABLED",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "persistsState" : true,
      "validationStatus" : "VALID, INVALID, VALIDATING",
      "properties" : {
        "key" : "properties"
      }
    },
    "permissions" : {
      "canRead" : true,
      "canWrite" : true
    },
    "id" : "id",
    "position" : {
      "x" : 6.027456183070403,
      "y" : 1.4658129805029452
    },
    "uri" : "uri",
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 0
    },
    "status" : {
      "activeThreadCount" : 0,
      "validationStatus" : "VALID, INVALID, VALIDATING",
      "runStatus" : "ENABLED, DISABLED"
    }
  } ]
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

FlowAnalysisRulesEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/registry-clients/{id}
Gets a flow registry client (getFlowRegistryClient)

Path parameters

id (required)
Path Parameter — The flow registry client id.

Return type

FlowRegistryClientEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "id" : 5,
      "sourceName" : "sourceName",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "annotationData" : "annotationData",
    "deprecated" : true,
    "description" : "description",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "type" : "type",
    "descriptors" : {
      "key" : {
        "supportsEl" : true,
        "displayName" : "displayName",
        "defaultValue" : "defaultValue",
        "expressionLanguageScope" : "expressionLanguageScope",
        "description" : "description",
        "sensitive" : true,
        "required" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName"
        } ],
        "allowableValues" : [ {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        }, {
          "canRead" : true,
          "allowableValue" : {
            "displayName" : "displayName",
            "description" : "description",
            "value" : "value"
          }
        } ],
        "identifiesControllerService" : "identifiesControllerService",
        "name" : "name",
        "dynamic" : true
      }
    },
    "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
    "supportsBranching" : true,
    "restricted" : true,
    "supportsSensitiveDynamicProperties" : true,
    "name" : "name",
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "validationStatus" : "VALID, INVALID, VALIDATING",
    "properties" : {
      "key" : "properties"
    }
  },
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "id" : "id",
  "position" : {
    "x" : 6.027456183070403,
    "y" : 1.4658129805029452
  },
  "uri" : "uri",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 0
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

FlowRegistryClientEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/registry-clients
Gets the listing of available flow registry clients (getFlowRegistryClients)

Return type

FlowRegistryClientsEntity

Example data

Content-Type: application/json
{
  "currentTime" : "currentTime",
  "registries" : [ {
    "bulletins" : [ {
      "sourceId" : "sourceId",
      "canRead" : true,
      "groupId" : "groupId",
      "id" : 5,
      "nodeAddress" : "nodeAddress",
      "bulletin" : {
        "sourceId" : "sourceId",
        "level" : "level",
        "sourceType" : "sourceType",
        "groupId" : "groupId",
        "id" : 5,
        "sourceName" : "sourceName",
        "category" : "category",
        "message" : "message",
        "nodeAddress" : "nodeAddress",
        "timestamp" : "timestamp"
      },
      "timestamp" : "timestamp"
    }, {
      "sourceId" : "sourceId",
      "canRead" : true,
      "groupId" : "groupId",
      "id" : 5,
      "nodeAddress" : "nodeAddress",
      "bulletin" : {
        "sourceId" : "sourceId",
        "level" : "level",
        "sourceType" : "sourceType",
        "groupId" : "groupId",
        "id" : 5,
        "sourceName" : "sourceName",
        "category" : "category",
        "message" : "message",
        "nodeAddress" : "nodeAddress",
        "timestamp" : "timestamp"
      },
      "timestamp" : "timestamp"
    } ],
    "disconnectedNodeAcknowledged" : true,
    "component" : {
      "annotationData" : "annotationData",
      "deprecated" : true,
      "description" : "description",
      "multipleVersionsAvailable" : true,
      "extensionMissing" : true,
      "type" : "type",
      "descriptors" : {
        "key" : {
          "supportsEl" : true,
          "displayName" : "displayName",
          "defaultValue" : "defaultValue",
          "expressionLanguageScope" : "expressionLanguageScope",
          "description" : "description",
          "sensitive" : true,
          "required" : true,
          "dependencies" : [ {
            "dependentValues" : [ "dependentValues", "dependentValues" ],
            "propertyName" : "propertyName"
          }, {
            "dependentValues" : [ "dependentValues", "dependentValues" ],
            "propertyName" : "propertyName"
          } ],
          "allowableValues" : [ {
            "canRead" : true,
            "allowableValue" : {
              "displayName" : "displayName",
              "description" : "description",
              "value" : "value"
            }
          }, {
            "canRead" : true,
            "allowableValue" : {
              "displayName" : "displayName",
              "description" : "description",
              "value" : "value"
            }
          } ],
          "identifiesControllerService" : "identifiesControllerService",
          "name" : "name",
          "dynamic" : true
        }
      },
      "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
      "supportsBranching" : true,
      "restricted" : true,
      "supportsSensitiveDynamicProperties" : true,
      "name" : "name",
      "validationErrors" : [ "validationErrors", "validationErrors" ],
      "id" : "id",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "validationStatus" : "VALID, INVALID, VALIDATING",
      "properties" : {
        "key" : "properties"
      }
    },
    "permissions" : {
      "canRead" : true,
      "canWrite" : true
    },
    "id" : "id",
    "position" : {
      "x" : 6.027456183070403,
      "y" : 1.4658129805029452
    },
    "uri" : "uri",
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 0
    }
  }, {
    "bulletins" : [ {
      "sourceId" : "sourceId",
      "canRead" : true,
      "groupId" : "groupId",
      "id" : 5,
      "nodeAddress" : "nodeAddress",
      "bulletin" : {
        "sourceId" : "sourceId",
        "level" : "level",
        "sourceType" : "sourceType",
        "groupId" : "groupId",
        "id" : 5,
        "sourceName" : "sourceName",
        "category" : "category",
        "message" : "message",
        "nodeAddress" : "nodeAddress",
        "timestamp" : "timestamp"
      },
      "timestamp" : "timestamp"
    }, {
      "sourceId" : "sourceId",
      "canRead" : true,
      "groupId" : "groupId",
      "id" : 5,
      "nodeAddress" : "nodeAddress",
      "bulletin" : {
        "sourceId" : "sourceId",
        "level" : "level",
        "sourceType" : "sourceType",
        "groupId" : "groupId",
        "id" : 5,
        "sourceName" : "sourceName",
        "category" : "category",
        "message" : "message",
        "nodeAddress" : "nodeAddress",
        "timestamp" : "timestamp"
      },
      "timestamp" : "timestamp"
    } ],
    "disconnectedNodeAcknowledged" : true,
    "component" : {
      "annotationData" : "annotationData",
      "deprecated" : true,
      "description" : "description",
      "multipleVersionsAvailable" : true,
      "extensionMissing" : true,
      "type" : "type",
      "descriptors" : {
        "key" : {
          "supportsEl" : true,
          "displayName" : "displayName",
          "defaultValue" : "defaultValue",
          "expressionLanguageScope" : "expressionLanguageScope",
          "description" : "description",
          "sensitive" : true,
          "required" : true,
          "dependencies" : [ {
            "dependentValues" : [ "dependentValues", "dependentValues" ],
            "propertyName" : "propertyName"
          }, {
            "dependentValues" : [ "dependentValues", "dependentValues" ],
            "propertyName" : "propertyName"
          } ],
          "allowableValues" : [ {
            "canRead" : true,
            "allowableValue" : {
              "displayName" : "displayName",
              "description" : "description",
              "value" : "value"
            }
          }, {
            "canRead" : true,
            "allowableValue" : {
              "displayName" : "displayName",
              "description" : "description",
              "value" : "value"
            }
          } ],
          "identifiesControllerService" : "identifiesControllerService",
          "name" : "name",
          "dynamic" : true
        }
      },
      "sensitiveDynamicPropertyNames" : [ "sensitiveDynamicPropertyNames", "sensitiveDynamicPropertyNames" ],
      "supportsBranching" : true,
      "restricted" : true,
      "supportsSensitiveDynamicProperties" : true,
      "name" : "name",
      "validationErrors" : [ "validationErrors", "validationErrors" ],
      "id" : "id",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "validationStatus" : "VALID, INVALID, VALIDATING",
      "properties" : {
        "key" : "properties"
      }
    },
    "permissions" : {
      "canRead" : true,
      "canWrite" : true
    },
    "id" : "id",
    "position" : {
      "x" : 6.027456183070403,
      "y" : 1.4658129805029452
    },
    "uri" : "uri",
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 0
    }
  } ]
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

FlowRegistryClientsEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/nar-manager/nars/{id}/details
Retrieves the component types available from the installed NARs (getNarDetails)

Path parameters

id (required)
Path Parameter — The id of the NAR.

Return type

NarDetailsEntity

Example data

Content-Type: application/json
{
  "controllerServiceTypes" : [ null, null ],
  "reportingTaskTypes" : [ null, null ],
  "narSummary" : {
    "identifier" : "identifier",
    "coordinate" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "sourceIdentifier" : "sourceIdentifier",
    "installComplete" : true,
    "buildTime" : "buildTime",
    "createdBy" : "createdBy",
    "sourceType" : "sourceType",
    "digest" : "digest",
    "extensionCount" : 0,
    "state" : "state",
    "failureMessage" : "failureMessage"
  },
  "flowAnalysisRuleTypes" : [ null, null ],
  "processorTypes" : [ {
    "deprecationReason" : "deprecationReason",
    "controllerServiceApis" : [ {
      "type" : "type"
    }, {
      "type" : "type"
    } ],
    "restricted" : true,
    "description" : "description",
    "explicitRestrictions" : [ {
      "requiredPermission" : {
        "id" : "id",
        "label" : "label"
      },
      "explanation" : "explanation"
    }, {
      "requiredPermission" : {
        "id" : "id",
        "label" : "label"
      },
      "explanation" : "explanation"
    } ],
    "usageRestriction" : "usageRestriction",
    "type" : "type",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "tags" : [ "tags", "tags" ]
  }, {
    "deprecationReason" : "deprecationReason",
    "controllerServiceApis" : [ {
      "type" : "type"
    }, {
      "type" : "type"
    } ],
    "restricted" : true,
    "description" : "description",
    "explicitRestrictions" : [ {
      "requiredPermission" : {
        "id" : "id",
        "label" : "label"
      },
      "explanation" : "explanation"
    }, {
      "requiredPermission" : {
        "id" : "id",
        "label" : "label"
      },
      "explanation" : "explanation"
    } ],
    "usageRestriction" : "usageRestriction",
    "type" : "type",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "tags" : [ "tags", "tags" ]
  } ],
  "parameterProviderTypes" : [ null, null ],
  "flowRegistryClientTypes" : [ null, null ],
  "dependentCoordinates" : [ null, null ]
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

NarDetailsEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /controller/nar-manager/nars
Retrieves summary information for installed NARs (getNarSummaries)

Return type

NarSummariesEntity

Example data

Content-Type: application/json
{
  "currentTime" : "currentTime",
  "narSummaries" : [ {
[...]
